Variable S : Type.

Definition pre := S -> Prop.
Definition post (A:Type) := A -> S -> S -> Prop.
Definition ST (P:pre) (A:Type) (Q:post A) :=
  forall s1:S, P s1 -> { u : A*S | Q (fst u) s1 (snd u) }.

Definition ret :
  forall A v, ST (fun _ => True) A (fun x s1 s2 => x = v /\ s1 = s2)
:= fun A v s1 H1 => exist _ (v,s1) (conj eq_refl eq_refl).

Definition bind :
  forall A B (P1:pre) (Q1:post A) (P2:A->pre) (Q2:A -> post B),
  let P := fun s1 => P1 s1 /\ forall a s2, Q1 a s1 s2 -> P2 a s2 in
  let Q := fun b s1 s3 => exists a s2, Q1 a s1 s2 /\ Q2 a b s2 s3 in
  ST P1 A Q1 -> (forall a, ST (P2 a) B (Q2 a)) -> ST P B Q.
Admitted.

Variable loc : Type->Type.
Variable valid : forall A, loc A -> S -> Prop.
Variable read : forall A, loc A -> S -> A.
Definition get :
  forall A (l:loc A),
    ST (fun s1 => valid _ l s1) A (fun x s1 s2 => x = read _ l s1 /\ s1 = s2).
Admitted.
